program gamesa_main;
uses gamesa, dynlibs, strings;

type dvojice = array [0..1] of longint;
type pdvojice = ^dvojice;
type pd = array [0..99999999] of dvojice;
type ppd = ^pd;

procedure wrap__herni_plan(n: longint; p: pointer); cdecl;
var d: ppd;
    a: array of dvojice;
    i: longint;
begin
   writeln('Herni plan: n=', n);
   d := ppd(p);
   SetLength(a, n-3);
   for i := 0 to n-4 do begin
      a[i] := d^[i];
      end;
   writeln('HP!');
   herni_plan(n, a);
end;

procedure wrap__tah_marenky(x, y: longint); cdecl;
var d: dvojice;
begin
   writeln('M ', x, y);
   d[0] := x;
   d[1] := y;
   tah_marenky(d);
end;

procedure wrap__tah_honzika(x: pdvojice); cdecl;
begin
   writeln('H');
   tah_honzika(x^);
end;

var wrap__libh: TLibHandle;

type gri = procedure (hp, th, tm: pointer); cdecl;
var wrap__gri: gri;

begin
   wrap__libh := LoadLibrary('./pascal-vyhodn.so');
   if wrap__libh = NilHandle then begin writeln('Cannot load p.so'); halt(42); end;

   wrap__gri := gri(GetProcedureAddress(wrap__libh, 'gamesa_run_it'));
   if wrap__gri = nil then begin writeln('Cannot resolve gamesa_run_it'); halt(42); end;

   wrap__gri(pointer(@wrap__herni_plan), pointer(@wrap__tah_honzika), pointer(@wrap__tah_marenky));
end.
