#include <cstdio>
#include <vector>
#define REP(i,b) for(int i=0;i<(b);i++)
using namespace std;

/* reseni */
#define MAXN 100001
int nazor[MAXN], pocty_hlasu[5], pocty_sousedu[MAXN][5];
vector<int> graf[MAXN], vyvoleni[MAXN];

void spioni (int n, int m, int znaji_se[][2], int voli[]) {
  REP(i, n) nazor[i] = voli[i];
  REP(i, m){
    graf[znaji_se[i][0]].push_back(znaji_se[i][1]);
    graf[znaji_se[i][1]].push_back(znaji_se[i][0]);
  }
  REP(i, m) {
    int a = znaji_se[i][0], b = znaji_se[i][1];
    if(nazor[a] == nazor[b]) pocty_hlasu[nazor[a]]++;
    if(graf[a].size() > graf[b].size()) {
      vyvoleni[b].push_back(a);
      pocty_sousedu[a][nazor[b]]++;
    }
    else {
      vyvoleni[a].push_back(b);
      pocty_sousedu[b][nazor[a]]++;
    }
  }
}

void zmen_nazor (int spion, int voli) {
  pocty_hlasu[nazor[spion]] -= pocty_sousedu[spion][nazor[spion]];
  pocty_hlasu[voli] += pocty_sousedu[spion][voli];
  REP(i, vyvoleni[spion].size()) {
    pocty_sousedu[vyvoleni[spion][i]][nazor[spion]]--;
    pocty_sousedu[vyvoleni[spion][i]][voli]++;
    if(nazor[vyvoleni[spion][i]] == nazor[spion]) pocty_hlasu[nazor[spion]]--;
    if(nazor[vyvoleni[spion][i]] == voli) pocty_hlasu[voli]++;
  }
  nazor[spion] = voli;
}

void pocet_bodu (int pocet[5]) {
  REP(i, 5) pocet[i] = pocty_hlasu[i];
}

#if 0
/* nasleduje nacitani vstupu a volani funkci z reseni */
int znaji_se[3*MAXN][2], voli[MAXN], vysledek[5];
int main(int argc, char *argv[]) {
  int N, M;
  scanf("%d%d", &N, &M); 
  REP(i, N) scanf("%d", voli + i);
  REP(i, M) scanf("%d%d", znaji_se[i], znaji_se[i] + 1);
  spioni(N, M, znaji_se, voli); 
  char cmd[5];
  while(scanf("%s", cmd) != EOF) {
    if(cmd[0] == 'P') {
      pocet_hlasu(vysledek);
      REP(i, 5) {
        if(i) printf(" ");
        printf("%d", vysledek[i]);
      }
      printf("\n");
    }
    else {
      int spion, nazor;
      scanf("%d%d", &spion, &nazor);
      zmen_nazor(spion, nazor);
    }
  }
  return 0;
}
#endif
